package com.company;

import com.sun.javafx.scene.control.skin.VirtualFlow;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Random;

public class Player {
    // List of player's cards
    private ArrayList<Card> playerCards = new ArrayList<>();
    // point of the player
    private int playerPoint;

    protected HashMap<Card, ArrayList<Card>> possibleCards = new HashMap<>();
    protected HashMap<String, ArrayList<Card>> possibleColorCards = new HashMap<>();
    private int counter = 0;

    /**
     * returns the list of player's cards
     * @return the list of player's cards
     */
    public ArrayList<Card> getPlayerCards() {
        return playerCards;
    }

    /**
     *
     * @param playerNumber
     */
    public void printAllCards(int playerNumber){
        System.out.println("Player" + playerNumber + ":");
        Iterator<Card> cardIterator = playerCards.iterator();
        while (cardIterator.hasNext()){
            Card c = cardIterator.next();
            System.out.println(c.toString());
        }
    }

    public int getCounter() {
        return counter;
    }

    public HashMap<Card, ArrayList<Card>> getPossibleCards() {
        return possibleCards;
    }

    public int getPlayerPoint() {
        Iterator<Card> cardIterator = playerCards.iterator();
        while (cardIterator.hasNext()){
            playerPoint += cardIterator.next().getCardPoint();
        }
        return playerPoint;
    }

    public void checkAllCards(Card card){
        boolean isColored = false;
        possibleCards.put(card, new ArrayList<Card>());
        if (card instanceof Colored)
            isColored = true;
        Iterator<Card> cardIterator = playerCards.iterator();
        while (cardIterator.hasNext()) {
            Card c = cardIterator.next();
            if (c instanceof Colored) {
                if (isColored)
                    if (((Colored) c).checkEquality((Colored) card))
                        possibleCards.get(card).add(c);
            }
            else
                possibleCards.get(card).add(c);
        }
        if (possibleCards.get(card).size() > 0) {
            if (possibleCards.get(card).size() != searchWildDraws(card))
                deleteWildDraws(card);
        }

    }

    public Card randomPunishmentCard(ArrayList<Card> cards){
        Random r = new Random();
        int next = r.nextInt(cards.size());
        return cards.get(next);
    }

    public void printAllPossibleCards(int playerNumber, Card cardToPrint){
        System.out.println("Player" + playerNumber + ": (Possible cards)");
        Iterator<Card> cardIterator = possibleCards.get(cardToPrint).iterator();
        while (cardIterator.hasNext()){
            Card c = cardIterator.next();
            System.out.println(c.toString());
        }
    }

    public void printAllPossibleColoredCards(int playerNumber, String colorToPrint){
        System.out.println("Player" + playerNumber + ": (Possible color cards)");
        Iterator<Card> cardIterator = possibleColorCards.get(colorToPrint).iterator();
        while (cardIterator.hasNext()){
            Card c = cardIterator.next();
            System.out.println(c.toString());
        }
    }


    private int searchWildDraws(Card card){
        int counterWildDraw = 0;
       Iterator<Card> cardIterator = possibleCards.get(card).iterator();
       while (cardIterator.hasNext()){
           Card c = cardIterator.next();
           if (c instanceof WildDraw)
               counterWildDraw++;
       }
       return counterWildDraw;
    }

    private void deleteWildDraws(Card card){
        for (int i = 0; i < possibleCards.get(card).size(); i++){
            if (possibleCards.get(card).get(i) instanceof WildDraw){
                possibleCards.get(card).remove(i);
                i--;
            }
        }
    }

    public Card chooseCardToThrow(ArrayList<Card> cards, Card c){
        return null;
    }

    public String chooseColorIfBlack(Card card){
        String s = null;
        return s;
    }

    public String toString(int playerNumber) {
        return "Player" + playerNumber +
                " {playerPoint=" + playerPoint +
                " }";
    }

    public void checkColors(String color){
        System.out.println("color = " + color);
        possibleColorCards.put(color, new ArrayList<Card>());
        Iterator<Card> cardIterator = playerCards.iterator();
        while (cardIterator.hasNext()) {
            Card c = cardIterator.next();
            if (c instanceof Colored)
               if(c.cardColor.equals(color))
                   possibleColorCards.get(color).add(c);
        }

    }

    public Card chooseColorToThrow(ArrayList<Card> cards, String Color){
        return null;
    }
}
